\timing
begin;
alter table txt add column tid serial, add column fts_index tsvector;
update txt set fts_index=to_tsvector( body );
create unique index tid_idx on txt (tid);
-- create inverted index 
select count(tdbulkindex ('select tid, fts_index from txt'));
-- ensure index is written on disk
select tdflush();
end;

vacuum full analyze;

-- simple search
explain analyze select count(*) from tdsearch(to_tsquery('oil'));

-- ranked search
explain analyze select txt.tid, rank(fts_index,to_tsquery('oil')) as rank
from txt, tdsearch(to_tsquery('oil')) as idx where tid=idx order by rank desc limit 10;

-- ranked search with text fragments, notice using subselects to avoid
-- needless calls of headline !
-- Argh, how to avoid double usage of to_tsquery ???

explain analyze select tid, headline(body, q), rank
from (select txt.tid as tid,  body, rank(fts_index,q) as rank,q
      from txt,to_tsquery('oil') q, tdsearch(to_tsquery('oil')) as idx
      where tid = idx order by rank desc limit 10) as foo;

-- Aha, looks ugly

select tid, headline(body, q), rank
from (select txt.tid as tid,  body, rank(fts_index,q) as rank, q
      from txt, (select tdsearch(q) as idx, q
                 from (select to_tsquery('oil') as q) as fooq
                ) as fooidx
      where tid = idx order by rank desc limit 10) as foo;
