#ifndef __TSEARCHD_H__
#define __TSEARCHD_H__

#include <sys/types.h>
/*
#include <db.h>
*/
#include <db_185.h>
#include <fcntl.h>
#include <limits.h>
#include "postgres.h"
#include "query.h"
#include "tscommunication.h"
#include "connection.h"

#ifndef TRUE
#define TRUE 	(1)
#endif

#ifndef FALSE
#define FALSE 	(0)
#endif

typedef struct {
	char 		*word;
	u_int32_t	len;
	/* WordData */
	int32_t		status;
	u_int32_t	num;
	int32_t		id[1];	
} AccEntry;

#define ACCEHRDRSZ	(sizeof(char*)+2*sizeof(u_int32_t) + sizeof(int32_t) )
#define ACCEWDHRDRSZ	(sizeof(char*)+sizeof(u_int32_t))

typedef struct StackEntry {
        char            *word;
        WordData        *data;
        u_int32_t       donotfree:1,
                        unused:31;
        struct StackEntry       *next;
} StackEntry;



typedef struct {
	DB *db;

	AccEntry **entries;
	u_int32_t lenentries;
	u_int32_t numentries;
	u_int32_t allocated;
	u_int32_t maxallocated;

	StackEntry *stack;
	StackEntry *cache;
} TDStorage;

TDStorage* TDOpenStorage(char *file);
void TDCloseStorage(TDStorage *storage);
void TDFlushStorage(TDStorage *storage);
void TDAppend( TDStorage *storage, char *word, int32_t id);
WordData* TDGet(TDStorage *storage, char *word);
void TDPut(TDStorage *storage, char *word, WordData *data);


typedef struct TDNode {
        struct TDNode *left;
        struct TDNode *right;
        struct TDNode *next;
	
	u_int32_t
		type:3,
		isfinita:1,
		cancache:1,
		unused:27;
	char *word;
}       TDNode;

#define TD_VAL		1
#define TD_AND		2
#define TD_OR		3
#define TD_NOT		4
#define TD_MINES	5

WordData*  TDExecute(TDStorage *storage, TDNode *root);
void freePolish(TDNode *node);
int prepareQuery(QUERYTYPE *tsquery, TDNode** res);


void
ConnectionWorks(PoolConnection *pool, TDStorage *storage);

#endif
